//MODO COMANDO POR EL PUERTO SERIAL 9600 BPS
//ENVIA "0K>" A TERMINAL Y RECIBE UN COMANDO DEL USUARIO:
//COMANDO R1=ENCIENDE RELEVADOR,
//COMANDO R0=APAGA RELEVADOR
//COMANDO T = ENVIA "TIEMPO="
//EL USUARIO DEBE ESCRIBIR EN SEGUNDOS,(MAXIMO 255)
//EL TIEMPO ASIGNADO PARA ACTIVAR EL RELEVADOR
//COMANDO S
//ESCRIBE EL VALOR DECIMAL DE LOS 4 MICROSWITCHES (0..15),
//"S=12" (EJEMPLO)
//DESPUES DE CADA COMANDO ENVIA "OK>"

#include <p18cxxx.h>
#include <delays.h>
#include <usart.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "18F2550BOLT.h"
#include "PUERTO-SERIAL-BOLT.h"
#include "ONEWIRE-BOLT.h"

extern void _startup( void ); 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 
#pragma code
			
void retraso(int a);
char a,b,c;
char array[16], micros[16],lcd[16];
char letrero1[8] = "Bolt C S", letrero2[8] = "harp App", letrero3[8] = "System r", letrero4[8] = "eady...", letrero5[8] = "waiting ";
char Impresion[16];
int numI = 0;
int TIEMPO,entero, decimal1, entero2,ESCRIBIENDO=0;
long int decimal;
int i;
float temp;
int cuenta=0;
int contador=0;

void main(void)
{
	//INICIALIZACIONES
	init_bolt();
	activa_serial();
	InitLCD();
	ClearScreen();
	
	//LETRERO INICIAL BOLT C SHARP APP
	GotoXY(0,0);
	PrintString(letrero1);
	GotoXY(1,0);
	PrintString(letrero2);
	delay_ms(2000);
	ClearScreen();

	while(1)
	{
		//LETRERO WAITING ...
		GotoXY(0,0);
		PrintString(letrero5);
		GotoXY(1,0);
		PutLCD('.');
		PutLCD('.');
		PutLCD('.');

		//A LA ESPERA DE UNA SEAL DEL PROGRAMA
		a=getcNOECO();

		//SI LLEGA LA SEAL REGRESA LA RESPUESTA
		if(a == 'I')
		{
			//LETRERO SYSTEM READY ...
			ClearScreen();
			GotoXY(0,0);
			PrintString(letrero3);
			GotoXY(1,0);
			PrintString(letrero4);
			delay_ms(2000);
			
			//BORRADO DE LCD, PUERTOS Y RELEVADOR
			//PARA COMENZAR EL INICIO DEL PROGRAMA
			ClearScreen();
			PORTB=cuenta;
			RELE = 0;
			
			//ENVIO DE LA SEAL AL PROGRAMA COMO RESPUESTA
			//PARA AVISARLE QUE YA ESTA CONECTADA
			b = 'R';
			putcUSART(b);
			break;
		}
	}

	while(1)
	{	
		if(ESCRIBIENDO == 1)
		{
			ClearScreen();
			for(i=0; i<numI; i++)
			{
				if(i > 7)
					GotoXY(1,i-8);
				else
					GotoXY(0,i);
				PutLCD(Impresion[i]);
			}
			delay_ms(10);
			putcUSART(0);
			ESCRIBIENDO = 0;
		}

		//COLOCAR LOS LEDS ENCENDIDOS
		PORTB=cuenta;

		//A LA ESPERA DE UNA SEAL
		a=getcNOECO();

		//OPCION DE SEALES
		switch(a)
		{
			case 'R':
			{
				if (RELE == 0)
					RELE=1;
				else
					RELE=0;
				break;
			}
			case 'U':
			{
				b=microsw();
				c = 'B';

				//Imprimir los microswitches
				ClearScreen();
				GotoXY(0,0);
				sprintf(micros,"%d",b);
				PrintString(micros);

				//Enviar los microswitches
				putcUSART(b);
				delay_ms(3000);

				//Enviar seal de borrado
				putcUSART(c);

				//BORRAR TODO en la PIC
				ClearScreen();
				numI = 0;
				break;
			}
			case 'T':
			{
				temp = ds1820_read();
				c = 'B';
				
				entero = temp;
				putcUSART(entero);
				delay_ms(10);
				decimal1 = (temp - entero)*100;
				putcUSART(decimal1);
				
				//Impresion de la temperatura en la PIC
				sprintf(array,"T=%d.%d",entero,decimal1);
				ClearScreen();
				GotoXY(0,0);
				PrintString(array);
				delay_ms(3000);
				
				//Seal de borrado
				putcUSART(c);

				//BORRAR TODO en la PIC
				ClearScreen();
				GotoXY(0,0);
				contador = 0;
				numI = 0;
				break;
			}
			case '1':
			{
				if(RB1==0)
					cuenta=cuenta+0x02;			
				else
					cuenta=cuenta-0x02;
				break;
			}
			case '2':
			{
				if(RB2==0)
					cuenta=cuenta+0x04;
				else
					cuenta=cuenta-0x04;
				break;
			}
			case '3':
			{
				if(RB3==0)
					cuenta=cuenta+0x08;
				else
					cuenta=cuenta-0x08;
				break;
			}
			case '4':
			{
				if(RB4==0)
					cuenta=cuenta+0x10;
				else
					cuenta=cuenta-0x10;
				break;
			}
			case '5':
			{
				if(RB5==0)
					cuenta=cuenta+0x20;
				else
					cuenta=cuenta-0x20;
				break;
			}
			case '6':
			{
				if(RB6==0)
					cuenta=cuenta+0x40;
				else
					cuenta=cuenta-0x40;
				break;
			}
			case '7':
			{
				if(RB7==0)
					cuenta=cuenta+0x80;
				else
					cuenta=cuenta-0x80;
				break;
			}
			case '0':
			{
				if(RB0==0)
					cuenta=cuenta+0x01;
				else
					cuenta=cuenta-0x01;
				break;
			}

			case 'L':
			{
				ESCRIBIENDO = 1;
				b=getcNOECO();
				//PutLCD(b);
				if(b == 0xB2)
				{
					numI--;
					//ClearScreen();
				}
				else
				{
					if(b == 0xB1)
					{

					}
					else
					{
						Impresion[numI] = b;
						numI++;
					}
				}
				break;
			}

			case 't':
			{
				RB0=0;
				RB1=1;
				RB2=0;
				RB3=1;
				RB4=0;
				RB5=1;
				RB6=0;
				RB7=1;
				break;
			}

			case 'I':
			{
				//LETRERO SYSTEM READY ...
				ClearScreen();
				GotoXY(0,0);
				PrintString(letrero3);
				GotoXY(1,0);
				PrintString(letrero4);
				delay_ms(2000);
				
				//BORRADO DE LCD, PUERTOS Y RELEVADOR
				//PARA COMENZAR EL INICIO DEL PROGRAMA
				ClearScreen();
				numI = 0;
				cuenta = 0;
				PORTB=cuenta;
				RELE = 0;
				
				//ENVIO DE LA SEAL AL PROGRAMA COMO RESPUESTA
				//PARA AVISARLE QUE YA ESTA CONECTADA
				b = 'R';
				putcUSART(b);
				break;
			}

			default:
			{
				PORTB=0;
			}
		}
	}
}


void retraso(int a)
{
	int b;
	for(b=0;b<a;b++)
	{
		delay_ms(1000);
	}
}
