﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        int led0 = 0, led1 = 0, led2 = 0, led3 = 0, led4 = 0, led5 = 0, led6 = 0, led7 = 0, rele = 0;
        Boolean banderaMS = false, banderaT = false;
        string[] comHab = new string[6];
        int j = 0;//Contador de los COM
        int contAnterior = 0;
        
        public Form1()
        {
            InitializeComponent();
            if (!serialPort1.IsOpen)
            {
                try
                {
                    serialPort1.Open();
                }
                catch (System.Exception e) //No encontró habilitado ninguno
                {
                    
                    //Seleccionará el puerto que se encuentra habilitado el puerto serial
                    for (int i = 3; i < 50; i++)
                    {
                        serialPort1.PortName = "COM" + i;
                        try
                        {
                            serialPort1.Open();
                            comHab[j] = serialPort1.PortName;
                            j++;
                            serialPort1.Close();
                        }
                        catch
                        {
                            //MessageBox.Show("Puerto no válido");
                            //return;
                        }
                    }

                    //Ver cuántos COM están habilitados
                    if (j == 1)//Sólo uno
                    {
                        //MessageBox.Show("Puerto " + comHab[0] + " habilitado");
                        serialPort1.PortName = comHab[0];
                        comboBox1.Text = comHab[0];
                        //serialPort1.Open();
                        //E_S_Senal();
                    }
                    else//Más puertos habilitados
                    {
                        if(j == 0)
                            MessageBox.Show("Plug in the PIC18F2550 to the serial port\nand choose the port number.");
                        else
                            MessageBox.Show("\tThere are " + j + " ports enable.\nChoose the port number of the PIC18F2550.");
                    }
                }
            }
            else
            {

            }
        }

        protected override void OnKeyDown(KeyEventArgs keyEvent)
        {
            if (keyEvent.KeyCode == Keys.Delete)
            {
                MessageBox.Show("'delete' was pressed.");
            }
            if (keyEvent.KeyCode == Keys.Escape)
            {
                MessageBox.Show("'Escape' was pressed.");
            }
        }


        private void E_S_Senal()
        {
            byte[] salida = new byte[1];
            int entrada;
            salida[0] = 0x49; //LETRA I
            try
            {
                serialPort1.Write(salida, 0, salida.Length);

                entrada = serialPort1.ReadByte();
            }
            catch(Exception exep)
            {
                Deshabilitar();
            }
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }

        private void label3_Click(object sender, EventArgs e)
        {
            byte[] salida = new byte[1];
            salida[0] = 0x52; //Letra R
            try
            {
                serialPort1.Write(salida, 0, salida.Length);
                Image imagen;
                if (rele == 0)
                {
                    imagen = protoP9.Image;
                    rele = 1;
                }
                else
                {
                    imagen = proto9.Image;
                    rele = 0;
                }
                label3.Image = imagen;
            }
            catch(Exception excep)
            {
                Deshabilitar();
            }
        }

        private void label4_Click(object sender, EventArgs e)
        {
            //Guardar el texto del LCD
            //String texto = LCD.Text;

            //Mandamos la señal a la PIC para recibir los MS
            byte[] salida = new byte[1];
            int entrada;
            salida[0] = 0x55; //Letra U
            try
            {
                serialPort1.Write(salida, 0, salida.Length);
                entrada = serialPort1.ReadByte();

                //Se muestran en pantalla 2 segundos
                banderaMS = true;
                LCD.Text = entrada + "";
            
                //Borrar los microswitches
                entrada = serialPort1.ReadByte();
                banderaMS = true;
                contAnterior = 0;
                LCD.Text = "";
            }
            catch (Exception excep)
            {
                Deshabilitar();
            }
            //Regresamos al texto anterior
            //banderaMS = true;
            //LCD.Text = texto;
        }

        private void label5_Click(object sender, EventArgs e)
        {
            byte[] salida = new byte[1];
            salida[0] = 0x37; //NUMERO 7
            try
            {
                serialPort1.Write(salida, 0, salida.Length);
                Image imagen;
                if (led7 == 0)
                {
                    imagen = protoP8.Image;
                    led7 = 1;
                }
                else
                {
                    imagen = proto8.Image;
                    led7 = 0;
                }
                label5.Image = imagen;
            }
            catch (Exception excep)
            {
                Deshabilitar();
            }
        }

        private void label6_Click(object sender, EventArgs e)
        {
            byte[] salida = new byte[1];
            salida[0] = 0x36; //NUMERO 6
            try
            {
                serialPort1.Write(salida, 0, salida.Length);
                Image imagen;
                if (led6 == 0)
                {
                    imagen = protoP7.Image;
                    led6 = 1;
                }
                else
                {
                    imagen = proto7.Image;
                    led6 = 0;
                }
                label6.Image = imagen;
            }
            catch (Exception excep)
            {
                Deshabilitar();
            }
        }

        private void label7_Click(object sender, EventArgs e)
        {
            byte[] salida = new byte[1];
            salida[0] = 0x35; //NUMERO 5
            try
            {
                serialPort1.Write(salida, 0, salida.Length);
                Image imagen;
                if (led5 == 0)
                {
                    imagen = protoP6.Image;
                    led5 = 1;
                }
                else
                {
                    imagen = proto6.Image;
                    led5 = 0;
                }
                label7.Image = imagen;
            }
            catch (Exception excep)
            {
                Deshabilitar();
            }
        }

        private void label8_Click(object sender, EventArgs e)
        {
            byte[] salida = new byte[1];
            salida[0] = 0x34; //NUMERO 4
            try
            {
                serialPort1.Write(salida, 0, salida.Length);
                Image imagen;
                if (led4 == 0)
                {
                    imagen = protoP5.Image;
                    led4 = 1;
                }
                else
                {
                    imagen = proto5.Image;
                    led4 = 0;
                }
                label8.Image = imagen;
            }
            catch (Exception excep)
            {
                Deshabilitar();
            }
        }

        private void label9_Click(object sender, EventArgs e)
        {
            byte[] salida = new byte[1];
            salida[0] = 0x33; //NUMERO 3
            try
            {
                serialPort1.Write(salida, 0, salida.Length);
                Image imagen;
                if (led3 == 0)
                {
                    imagen = protoP4.Image;
                    led3 = 1;
                }
                else
                {
                    imagen = proto4.Image;
                    led3 = 0;
                }
                label9.Image = imagen;
            }
            catch (Exception excep)
            {
                Deshabilitar();
            }
        }

        private void label10_Click(object sender, EventArgs e)
        {
            byte[] salida = new byte[1];
            salida[0] = 0x32; //NUMERO 2
            try
            {
                serialPort1.Write(salida, 0, salida.Length);
                Image imagen;
                if (led2 == 0)
                {
                    imagen = protoP3.Image;
                    led2 = 1;
                }
                else
                {
                    imagen = proto3.Image;
                    led2 = 0;
                }
                label10.Image = imagen;
            }
            catch (Exception excep)
            {
                Deshabilitar();
            }
        }

        private void label11_Click(object sender, EventArgs e)
        {
            byte[] salida = new byte[1];
            salida[0] = 0x31; //NUMERO 1
            try
            {
                serialPort1.Write(salida, 0, salida.Length);
                Image imagen;
                if (led1 == 0)
                {
                    imagen = protoP2.Image;
                    led1 = 1;
                }
                else
                {
                    imagen = proto2.Image;
                    led1 = 0;
                }
                label11.Image = imagen;
            }
            catch (Exception excep)
            {
                Deshabilitar();
            }
        }

        private void label12_Click(object sender, EventArgs e)
        {
            byte[] salida = new byte[1];
            salida[0] = 0x30; //NUMERO 0
            try
            {
                serialPort1.Write(salida, 0, salida.Length);
                Image imagen;
                if (led0 == 0)
                {
                    imagen = protoP1.Image;
                    led0 = 1;
                }
                else
                {
                    imagen = proto1.Image;
                    led0 = 0;
                }
                label12.Image = imagen;
            }
            catch (Exception excep)
            {
                Deshabilitar();
            }
        }

        private void label31_Click(object sender, EventArgs e)
        {
            //String texto = LCD.Text;
            
            byte[] salida = new byte[1];
            int entero;
            int decimal0;
            
            salida[0] = 0x54; //Letra T
            try
            {
                serialPort1.Write(salida, 0, salida.Length);
                entero = serialPort1.ReadByte();
                decimal0 = serialPort1.ReadByte();

                banderaT = true;
                LCD.Text = "T=" + entero + "." + decimal0;

                //Borrado 
                entero = serialPort1.ReadByte();
                contAnterior = 0;
                banderaT = true;
                LCD.Text = "";
            }
            catch (Exception excep)
            {
                Deshabilitar();
            }
        }
        
        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            if (banderaMS || banderaT)
            {
                banderaMS = false;
                banderaT = false;
            }
            else
            {
                byte[] salida = new byte[1];
                int entero;

                salida[0] = 0x4C; //Letra L
                try
                {
                    serialPort1.Write(salida, 0, salida.Length);

                    //salida[0] = 0x4C;
                    //System.Threading.Thread.Sleep(1000);

                    if (contAnterior > LCD.Text.Length)
                    {
                        salida[0] = 0xB2;
                    }
                    else
                    {
                        if (LCD.Text.Length == 0)
                            salida[0] = 0xB1;
                        else
                            salida[0] = (byte)LCD.Text[LCD.Text.Length - 1];
                    }

                    serialPort1.Write(salida, 0, salida.Length);
                    contAnterior = LCD.Text.Length;
                    entero = serialPort1.ReadByte();
                }
                catch (Exception excep)
                {
                    Deshabilitar();
                }
            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            serialPort1.PortName = comboBox1.Text;
            try
            {
                serialPort1.Open();
                comboBox1.Enabled = false;
                Bloqueo.Visible = false;
                E_S_Senal();
            }
            catch(Exception ex)
            {
                MessageBox.Show("Invalid port.");
            }   
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        //LABEL 34 Y 35 SON LAS IMAGENES DE LOS LEDS
        private void label34_Click(object sender, EventArgs e)
        {

        }

        private void label35_Click(object sender, EventArgs e)
        {

        }

        private void proto1_Click(object sender, EventArgs e)
        {

        }  

        private void reset_Click(object sender, EventArgs e)
        {
            E_S_Senal();
            ResetAll();
        }

        private void ResetAll()
        {
            banderaT = true;
            LCD.Text = "";
            contAnterior = 0;
            led0 = 0; led1 = 0; led2 = 0; led3 = 0; led4 = 0; led5 = 0; led6 = 0; led7 = 0; rele = 0;
            banderaMS = false; banderaT = false;
            label5.Image = proto8.Image;
            label6.Image = proto7.Image;
            label7.Image = proto6.Image;
            label8.Image = proto5.Image;
            label9.Image = proto4.Image;
            label10.Image = proto3.Image;
            label11.Image = proto2.Image;
            label12.Image = proto1.Image;
            label3.Image = proto9.Image;
        }

        private void Deshabilitar()
        {
            Bloqueo.Visible = true;
            comboBox1.Enabled = true;
            ResetAll();
            MessageBox.Show("Lost connection with the device.\n\tSelect number port.");
        }

        private void Bloqueo_Click(object sender, EventArgs e)
        {

        }

        private void LCD_KeyPress_1(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Escape)
            {
                reset_Click(sender, e);
            }
        }

        //
    }
}
